local addonName, at = ...

at.Adjunct = {
	InInstance = false,
	InQueue = false,
	timer = 0,
	QueueStatusReady = false,
	Addons = {
		capture = {
			'NXMiniMapBut',
		},
		ignore = {
			'QuestPointer',
		},
	},
	ButtonFrame = CreateFrame("Button", addonName .. "ButtonFrame", UIParent),
}
LoadAddOn('Blizzard_TimeManager')
local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
at.Minimap = {minimap = Minimap,}


function at.Adjunct:SetFonts()
	local sub = at.Settings.Map
	local zoneFont = sub.Zone.Font
	if zoneFont.name == nil then zoneFont.name = [[Fonts\FRIZQT__.TTF]] end
	MinimapZoneText:SetFont(zoneFont.name, zoneFont.size, zoneFont.style)
	at.Adjunct.WandererInfoText:SetFont(zoneFont.name, zoneFont.size, zoneFont.style)
	MinimapZoneTextButton:SetHeight(zoneFont.size + 2)


	local coordFont = sub.Coords.Font
	if coordFont.name == nil then coordFont.name = [[Fonts\FRIZQT__.TTF]] end
	at.Adjunct.CoordsFrameText:SetFont(coordFont.name, coordFont.size, coordFont.style)
	at.Adjunct.CoordsFrameText:SetText("Hook Failed!")
	at.Adjunct.CoordsFrame:SetHeight(at.Adjunct.CoordsFrameText:GetStringHeight())
	clockTime:SetFont(coordFont.name, coordFont.size, coordFont.style)
	at.Adjunct.DateText:SetFont(coordFont.name, coordFont.size, coordFont.style)
	at.Adjunct.DateText:SetText(date("%a %b %d"))

	at.Adjunct.SetFonts = function()
		local sub = at.Settings.Map.Zone.Font
		if sub.name == nil then sub.name = [[Fonts\FRIZQT__.TTF]] end
		MinimapZoneText:SetFont(sub.name, sub.size, sub.style)
		at.Adjunct.WandererInfoText:SetFont(sub.name, sub.size, sub.style)
		MinimapZoneTextButton:SetHeight(sub.size + 2)

		sub = at.Settings.Map.Coords.Font
		if sub.name == nil then sub.name = [[Fonts\FRIZQT__.TTF]] end
		at.Adjunct.CoordsFrameText:SetFont(sub.name, sub.size, sub.style)
		at.Adjunct.CoordsFrame:SetHeight(sub.size + 2)
		local _, clockTime = TimeManagerClockButton:GetRegions()
		clockTime:SetFont(sub.name, sub.size, sub.style)
		at.Adjunct.DateText:SetFont(sub.name, sub.size, sub.style)
	end
end
--Zone text
Minimap:SetMovable(true)
Minimap:EnableMouse(true)
Minimap:ClearAllPoints()
Minimap:SetPoint('TOPRIGHT', UIParent, 'TOPRIGHT', -20, -20)
Minimap:SetUserPlaced(true)

MinimapZoneTextButton:SetMovable(true)
MinimapZoneTextButton:EnableMouse(true)
MinimapZoneTextButton:SetParent(UIParent)
MinimapZoneTextButton:ClearAllPoints()
MinimapZoneTextButton:SetPoint('BOTTOM', Minimap, 'TOP', 0, MinimapZoneTextButton:GetHeight())
MinimapZoneTextButton:SetFrameStrata(Minimap:GetFrameStrata())
MinimapZoneText:ClearAllPoints()
MinimapZoneText:SetPoint('CENTER', MinimapZoneTextButton, 'CENTER')

MinimapZoneTextButton:RegisterForDrag("LeftButton","RightButton")
MinimapZoneTextButton:SetScript("OnDragStart", function(self) if IsAltKeyDown() and IsShiftKeyDown() then at.Minimap.minimap:StartMoving() end end)
MinimapZoneTextButton:SetScript("OnDragStop", function(self) at.Minimap.minimap:StopMovingOrSizing() end)
at.Minimap.minimap:HookScript("OnHide", function(self) self:StopMovingOrSizing() end)

--move the TimeManagerFrame
TimeManagerFrame:SetMovable(true)
TimeManagerFrame:EnableMouse(true)
TimeManagerFrame:SetUserPlaced(true)
TimeManagerFrame:SetClampedToScreen(true)
TimeManagerFrame:RegisterForDrag('LeftButton', 'Rightbutton')
TimeManagerFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
TimeManagerFrame:SetScript("OnDragStop", function(self) self:StopMovingOrSizing() end)
TimeManagerFrame:HookScript("OnHide", function(self) self:StopMovingOrSizing() end)


--Instance Difficulty and Queue Status
--	Inspired by
--		the honorable Phanx @ http://www.wowinterface.com/forums/showthread.php?t=46622
--		LFGStatusIcon @ http://www.wowinterface.com/downloads/info15273-LFGStatusIcon.html
QueueStatusMinimapButton:HookScript("OnHide", function()
	at.Adjunct.InQueue = false
	at.Adjunct.QueueStatusReady = false
	at.Adjunct.WandererInfoText:Update()
end)
QueueStatusMinimapButton:HookScript("OnShow", function() at.Adjunct.InQueue = true end)
QueueStatusMinimapButton:SetMovable(true)
QueueStatusMinimapButton:SetParent(MinimapZoneTextButton)
QueueStatusMinimapButton:ClearAllPoints()
QueueStatusMinimapButton:SetPoint('TOPRIGHT', UIParent, 'BOTTOMLEFT', -20, -20)

MiniMapInstanceDifficulty:HookScript("OnHide", function() at.Adjunct.InInstance = false at.Adjunct.WandererInfoText:Update() end)
MiniMapInstanceDifficulty:HookScript("OnShow", function() at.Adjunct.InInstance = true end)
MiniMapInstanceDifficulty:SetMovable(true)
MiniMapInstanceDifficulty:SetParent(UIParent)
MiniMapInstanceDifficulty:ClearAllPoints()
MiniMapInstanceDifficulty:SetPoint('TOPRIGHT', UIParent, 'BOTTOMLEFT', -20, -20)

at.Adjunct.WandererInfoText = at.Core:CreateFontString(addonName .. "WandererInfoText",'OVERLAY')
at.Adjunct.WandererInfoText:SetTextColor(0.0, 1.0, 0.0)
at.Adjunct.WandererInfoText:SetPoint('TOPLEFT', Minimap, 'TOPLEFT')

at.Adjunct.InstanceAnimationGroup = WorldFrame:CreateAnimationGroup()
at.Adjunct.InstanceAnimationTimer = at.Adjunct.InstanceAnimationGroup:CreateAnimation('Animation')
at.Adjunct.InstanceAnimationTimer:SetScript('OnFinished', function()
	QueueStatusMinimapButton:ClearAllPoints()
	QueueStatusMinimapButton:SetPoint('TOPRIGHT', UIParent, 'BOTTOMLEFT', -20, -20)
	QueueStatusMinimapButtonDropDown:Hide()
end)
at.Adjunct.InstanceAnimationTimer:SetDuration(13)

function at.Adjunct.WandererInfoText:Update()
	local sub = ''
	if at.Adjunct.InQueue and at.Adjunct.QueueStatusReady then
		local hasData, leaderNeeds, tanks, healers, dps, totalTanks, totalHealers, totalDPS, Type,
         SubType, instanceName, averageWait, tankWait, healerWait, dpsWait, myWait, queuedTime =
         GetLFGQueueStats(LE_LFG_CATEGORY_LFD)
        if not not hasData then
			if tanks > 0 then
				sub = sub .. tanks
			else
				sub = sub .. "_"
			end
			if healers > 0 then
				sub = sub .. healers
			else
				sub = sub .. "_"
			end
			if dps > 0 then
				sub = sub .. dps
			else
				sub = sub .. "_"
			end
			if tanks + healers + dps > 0 and at.Adjunct.InInstance then sub = sub .. " " end
		end
	end
	if at.Adjunct.InInstance then
		local instance, instanceType, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID = GetInstanceInfo()
		local difname, groupType, isHeroic, isChallengeMode, difficultyID = GetDifficultyInfo(difficulty)
		local numPlayers = GetNumGroupMembers()
		if numPlayers == 0 then numPlayers = 1 end
		sub = sub .. string.format("%d%s", numPlayers, isChallengeMode and "++" or isHeroic and "+" or "")
	end
	self:SetText(sub)
end

function at.Events:RAID_ROSTER_CHANGED()
	at.Adjunct.WandererInfoText:Update()
end
function at.Events:PARTY_MEMBERS_CHANGED()
	at.Adjunct.WandererInfoText:Update()
end

function at.Events:LFG_QUEUE_STATUS_UPDATE()
	at.Adjunct.QueueStatusReady = true
	at.Adjunct.WandererInfoText:Update()
end

MiniMapInstanceDifficulty:HookScript("OnEvent", function(self, event, ...)
	if event == "GUILD_PARTY_STATE_UPDATED" then
		self.__isGuildGroup = ...
	end
end)
function MiniMapInstanceDifficulty_Update()
	local instance, instanceType, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID = GetInstanceInfo()

	if MiniMapInstanceDifficulty.__isGuildGroup then
		instanceType = "GUILD"
	end

	local color = ChatTypeInfo[strupper(instanceType)]

	if color and maxPlayers > 0 then
		MiniMapInstanceDifficulty:Show()
		at.Adjunct.WandererInfoText:Update()
		at.Adjunct.WandererInfoText:SetTextColor(color.r*255, color.g*255, color.b*255)
	else
		MiniMapInstanceDifficulty:Hide()
	end
end
function at.Adjunct:UpdateZoneTooltip(self)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("TOP", self, "BOTTOM", 0, -4)
	GameTooltip:AddLine(GetZoneText(), 1,1,1)
	local r,g,b,a = MinimapZoneText:GetTextColor()
	GameTooltip:AddLine(GetSubZoneText(), r, g, b)
	if at.Adjunct.InInstance then
		local name, instanceType, difficulty, difficultyName, maxPlayers, playerDifficulty, isDynamicInstance, mapID = GetInstanceInfo()

		local numPlayers = GetNumGroupMembers()
		if numPlayers == 0 then numPlayers = 1 end
		GameTooltip:AddLine(name, 1, 0.82, 0)
		GameTooltip:AddLine(difficultyName, 1, 1, 1)
		GameTooltip:AddLine(numPlayers .. "/" .. maxPlayers, 1, 1, 1)

		if self.__isGuildGroup then
			GameTooltip:AddLine(GUILD, 1, 1, 1)
		end
	end
	if at.Adjunct.InQueue and at.Adjunct.QueueStatusReady then
		local _, _, tanks, healers, dps, totalTanks, totalHealers, totalDPS, _,  _, _, averageWait, tankWait, healerWait, dpsWait, myWait, queuedTime = GetLFGQueueStats(LE_LFG_CATEGORY_LFD)
		GameTooltip:AddLine(at.Global.TANK .. ": " .. totalTanks-tanks .. '/' .. totalTanks, 1, 1, 1)
		GameTooltip:AddLine(at.Global.HEALER .. ": " .. totalHealers-healers .. '/' .. totalHealers, 1, 1, 1)
		GameTooltip:AddLine(at.Global.DAMAGE .. ": " .. totalDPS-dps .. '/' .. totalDPS, 1, 1, 1)

		GameTooltip:AddLine(string.format(at.Global.TIME_IN_QUEUE, at.Abet:FormatTime(GetTime() - queuedTime)))
		GameTooltip:AddLine(at.Global.AVERAGE_WAIT_TIME .. " " .. at.Abet:FormatTime(myWait))
	end

	GameTooltip:Show()
end
MinimapZoneTextButton:HookScript("OnEnter", function(self)
	at.Adjunct:UpdateZoneTooltip(self)
end)
MinimapZoneTextButton:HookScript("OnLeave", function()
	QueueStatusFrame:Hide()
	GameTooltip:Hide()
end)


--Addon icons into frame handler
function at.Adjunct:FindMinimapChildren()
	for x = 1, GetNumAddOns() do
		local name, title, notes, enabled, loadable, reason, security = GetAddOnInfo(x or addonName)
		if enabled and reason ~= 'MISSING' and name ~= addonName then
			tinsert(at.Cache.Addons.capture, name)
		end
	end
	at.Adjunct.FindMinimapChildren = nil
end
function at.Adjunct:CreateAddonButtonFrame(aTable)
	at.Adjunct.ButtonFrame:SetMovable(true)
	at.Adjunct.ButtonFrame:EnableMouse(true)
	at.Adjunct.ButtonFrame:SetClampedToScreen(true)
	at.Adjunct.ButtonFrame:RegisterForDrag('LeftButton')
	at.Adjunct.ButtonFrame:SetScript("OnDragStart", function(self) self:StartMoving() end)
	at.Adjunct.ButtonFrame:SetScript("OnDragStop", function(self)
		self:StopMovingOrSizing()
		local point, _, relate, x, y = at.Adjunct.ButtonFrame:GetPoint()
		at.Settings.Addons.ButtonFrame.Position= {
			point = point,
			relative = relate,
			x = x,
			y = y,
		}
	end)
	at.Adjunct.ButtonFrame:HookScript("OnHide", function(self)
		self:StopMovingOrSizing()
		local point, _, relate, x, y = at.Adjunct.ButtonFrame:GetPoint()
		at.Settings.Addons.ButtonFrame.Position= {
			point = point,
			relative = relate,
			x = x,
			y = y,
		}
	end)
	at.Adjunct.ButtonFrame:ClearAllPoints()
	at.Adjunct.ButtonFrame:SetPoint(aTable.Position.point, UIParent, aTable.Position.relative, aTable.Position.x, aTable.Position.y)
	at.Adjunct.ButtonFrame:SetHeight(40)
	at.Adjunct.ButtonFrame:SetWidth(40)

	at.Adjunct.ButtonFrame.texture = at.Adjunct.ButtonFrame:CreateTexture(nil, 'ARTWORK')
	at.Adjunct.ButtonFrame.texture:SetTexture([[Interface\Buttons\CancelButton-Highlight]])
	at.Adjunct.ButtonFrame.texture:ClearAllPoints()
	at.Adjunct.ButtonFrame.texture:SetAllPoints(at.Adjunct.ButtonFrame)
	if at.Settings.Addons.ButtonFrame.Fade.enabled then
		at.Adjunct.ButtonFrame:Hide()
	else
		at.Adjunct.ButtonFrame:Show()
	end
	at.Adjunct.ButtonFrame:SetScript("OnShow", function(self)
		local sub = at.Settings.Addons.ButtonFrame
		local prev = self
		local wrap = self
		local count = 0
		for index, v in pairs({self:GetChildren()}) do
			v:ClearAllPoints()
			count = count +1
			if v:IsShown() then
				if sub.wrap > 0 and count > sub.wrap then
					v:SetPoint(at.Cache.Addons.directions[sub.direction][1], wrap, at.Cache.Addons.directions[sub.direction][2], 0, 0)
					wrap = v
					count = 0
				else
					v:SetPoint(at.Cache.Addons.directions[sub.growth][1], prev, at.Cache.Addons.directions[sub.growth][2], 0, 0)
				end
				prev = v
			end
		end
	end)
	at.Adjunct.ButtonFrameAnimationGroup = WorldFrame:CreateAnimationGroup()
	at.Adjunct.ButtonFrameTimer = at.Adjunct.ButtonFrameAnimationGroup:CreateAnimation('Animation')
	at.Adjunct.ButtonFrameTimer:SetScript('OnFinished', function()
		if at.Settings.Addons.ButtonFrame.Fade.enabled then
			at.Adjunct.ButtonFrame:Hide()
		end
	end)
	at.Adjunct.ButtonFrameTimer:SetDuration(at.Settings.Addons.ButtonFrame.Fade.value)
	at.Adjunct.CreateAddonButtonFrame = nil
end

MinimapZoneTextButton:RegisterForClicks('RightButtonUp', 'LeftButtonUp')
MinimapZoneTextButton:SetScript("OnClick", function(self, button, ...)
	if IsAltKeyDown() or IsShiftKeyDown() then return end
	if button == 'RightButton' then
		if at.Adjunct.ButtonFrame:IsVisible() then
			at.Adjunct.ButtonFrameAnimationGroup:Stop()
			at.Adjunct.ButtonFrame:Hide()
		else
			at.Adjunct.ButtonFrame:Show()
			at.Adjunct.ButtonFrameAnimationGroup:Play()
		end
	elseif button == 'LeftButton' and at.Adjunct.InQueue then
		local x, y = GetCursorPosition()
		local scale = UIParent:GetEffectiveScale()
		QueueStatusMinimapButton:Show()
		QueueStatusMinimapButton:ClearAllPoints()
		QueueStatusMinimapButton:SetPoint('RIGHT', UIParent, 'BOTTOMLEFT', x/scale - 5, y/scale)
		at.Adjunct.InstanceAnimationGroup:Play()
	end
end)

--Mail
MiniMapMailBorder:Hide()
MiniMapMailIcon:SetTexture(at.Cache.Directory .. [[\media\mail]])

--Map Coordinates
at.Adjunct.CoordsFrame = CreateFrame("Button", addonName .. "CoordsFrame", UIParent)

at.Adjunct.CoordsFrameText = at.Adjunct.CoordsFrame:CreateFontString(addonName .. "CoordsFrameText",'OVERLAY')--,"NumberFontNormalSmall")
at.Adjunct.CoordsFrameText:SetTextColor(0.0, 1.0, 0.0)
at.Adjunct.CoordsFrameText:SetPoint('CENTER', at.Adjunct.CoordsFrame)
at.Adjunct.CoordsFrameText:SetWidth(Minimap:GetWidth())

at.Adjunct.CoordsFrame:SetMovable(true)
at.Adjunct.CoordsFrame:ClearAllPoints()
at.Adjunct.CoordsFrame:SetParent(UIParent)
at.Adjunct.CoordsFrame:SetPoint('CENTER', Minimap, 'BOTTOM', 0, 0)
at.Adjunct.CoordsFrame:SetWidth(Minimap:GetWidth())
at.Adjunct.CoordsFrame:Hide()

-- Time/Date
clockFrame:Hide()
clockTime:Show()
GameTimeFrame:SetParent(UIParent)
TimeManagerClockButton:EnableMouse(false)
TimeManagerClockButton:SetParent(UIParent)
TimeManagerClockButton:ClearAllPoints()
TimeManagerClockButton:SetPoint('CENTER', Minimap, 'BOTTOM', -2, 0)
clockTime:Hide()

--date
at.Adjunct.DateText = TimeManagerClockButton:CreateFontString(nil, 'BACKGROUND')
at.Adjunct.DateText:SetParent(TimeManagerClockButton)
at.Adjunct.DateText:ClearAllPoints()
at.Adjunct.DateText:SetPoint('TOP', clockTime, 'BOTTOM')
at.Adjunct.DateText:SetTextColor(clockTime:GetTextColor())

local group = WorldFrame:CreateAnimationGroup()
local atimer = group:CreateAnimation('Animation')
atimer:SetScript('OnFinished', function()
	at.Adjunct.DateText:SetText(date("%a %b %d"))
end)
atimer:SetDuration(30)
group:SetLooping('REPEAT')
group:Play()
at.Adjunct.DateText:Hide()

Minimap:SetScript('OnEnter', function()
    clockTime:Show()
    if at.Settings.Map.Date then at.Adjunct.DateText:Show() else at.Adjunct.DateText:Hide() end
    if at.Settings.Map.Coords.enabled then UIFrameFadeOut(at.Adjunct.CoordsFrame, 0.2, at.Settings.Map.Coords.alpha, 0) end
    UIFrameFadeIn(TimeManagerClockButton, 0.2, 0, 1)
end)
Minimap:SetScript('OnLeave', function()
    UIFrameFadeOut(TimeManagerClockButton, 0.2, 1, 0)
    if at.Settings.Map.Coords.enabled then UIFrameFadeIn(at.Adjunct.CoordsFrame, 0.2, 0, at.Settings.Map.Coords.alpha) end
end)
GameTimeFrame:HookScript('OnEvent', function()
	if CalendarGetNumPendingInvites() > 0 then
		clockTime:SetTextColor(0, 1, 0)
	else
		clockTime:SetTextColor(1, 1, 1)
	end
end)

local GetPlayerMapPosition = GetPlayerMapPosition
Minimap:HookScript('OnUpdate', function(self, elapsed, ...)
	local x, y = GetPlayerMapPosition('player')
	if x>0 or y>0 then
		at.Adjunct.CoordsFrameText:SetFormattedText("%0.2f " .. at.Settings.Map.Coords.spacer .. " %0.2f",x*100,y*100)
	else
		at.Adjunct.CoordsFrameText:SetText("")
	end
end)

--combat hide
function at.Adjunct:CombatStart(flag)
	at.Cache.InCombat = flag
	if at.Settings.Map.Zone.combat then
		UIFrameFadeOut(MinimapZoneTextButton, 0.2, at.Settings.Map.Zone.alpha, at.Settings.Map.Zone.fade)
	end
	if at.Settings.Map.Compass.combat then
		UIFrameFadeOut(compFrame, 0.2, at.Settings.Map.Compass.alpha, at.Settings.Map.Compass.fade)
	end
	if at.Settings.Map.Icons.combat then UIFrameFadeOut(at.Core, 0.2, at.Settings.Map.Icons.alpha, at.Settings.Map.fade) end
	if at.Settings.Map.combat then
		at.Minimap:Update('combat')
	else at.Minimap.minimap:SetAlpha(at.Settings.Map.alpha)
	end
end
function at.Adjunct:CombatEnd(flag)
	at.Cache.InCombat = flag
	if at.Settings.Map.Zone.combat then
		UIFrameFadeIn(MinimapZoneTextButton, 0.2, at.Settings.Map.Zone.fade, at.Settings.Map.Zone.alpha)
	end
	if at.Settings.Map.Compass.combat then
		UIFrameFadeIn(at.Compass.CompassFrame, 0.2, at.Settings.Map.Compass.fade, at.Settings.Map.Compass.alpha)
	end
	if at.Settings.Map.Icons.combat then UIFrameFadeIn(at.Core, 0.2, at.Settings.Map.fade, at.Settings.Map.Icons.alpha) end
	if at.Settings.Map.combat then
		at.Minimap:Update('nocombat')
	else
		at.Minimap.minimap:SetAlpha(at.Settings.Map.alpha)
	end
end
function at.Events:PLAYER_REGEN_DISABLED()
	at.Adjunct:CombatStart(true)
end
function at.Events:PLAYER_REGEN_ENABLED()
	at.Adjunct:CombatEnd(false)
end
function at.Events:PET_BATTLE_CLOSE()
	if at.Settings.PetBattle then
		at.Adjunct.CombatEnd(at.Cache.InCombat)
	end
end
function at.Events:PET_BATTLE_OPENING_START()
	if at.Settings.PetBattle then
		at.Adjunct.CombatStart(at.Cache.InCombat)
	end
end
function at.Events:MINIMAP_UPDATE_ZOOM()--going in/outside
	if not at.Cache.InCombat then at.Minimap:Update('zone') end
end
function at.Events.PLAYER_UPDATE_RESTING()--resting often indicates a map that can't be displayed with alpha
	if not at.Cache.InCombat then at.Minimap:Update('rest') end
end
function at.Events.ZONE_CHANGED()
	if not WorldMapFrame:IsShown() then
		SetMapToCurrentZone()
	end
	if not at.Cache.InCombat then at.Minimap:Update('zone') end
end
function at.Events.ZONE_CHANGED_INDOORS()
	if not WorldMapFrame:IsShown() then
		SetMapToCurrentZone()
	end
	if not at.Cache.InCombat then at.Minimap:Update('zone') end
end
function at.Events.ZONE_CHANGED_NEW_AREA()
	if not WorldMapFrame:IsShown() then
		SetMapToCurrentZone()
	end
	if not at.Cache.InCombat then at.Minimap:Update('zone') end
end

