local addonName, at = ...

at.Compass = {}

--create the frame and textures
at.Compass.CompassFrame = CreateFrame('Button', addonName .. "Compass", UIParent)
at.Compass.CompassFrame:EnableMouse(false)
at.Compass.CompassFrame:SetMovable(true)
at.Compass.CompassFrame:SetSize(Minimap:GetWidth() + 24, 10)
at.Compass.CompassFrame:SetPoint('CENTER', Minimap, 'TOP')

--create the pointer indicating the direction faced
local pointer = at.Compass.CompassFrame:CreateTexture(nil, 'ARTWORK')
pointer:SetTexture([[Interface\MainMenuBar\UI-ExhaustionTickNormal]])
pointer:SetParent(at.Compass.CompassFrame)
pointer:SetPoint('CENTER', at.Compass.CompassFrame, 'CENTER')
--at.Compass.frame.pointer = pointer

--load the actual texture for the compass
local compass = at.Compass.CompassFrame:CreateTexture(nil, 'ARTWORK')
compass:SetTexture([[Interface\Addons\]] .. addonName .. [[\media\compass]])
compass:SetParent(at.Compass.CompassFrame)
compass:SetPoint('CENTER', at.Compass.CompassFrame, 'TOP')
--at.Compass.frame.compass = compass

--math
local ADJ_FACTOR, DEG_TO_COORD, PI = 1 / math.rad(720), 1 / 1440, math.rad(180)
local timer, adjCoord, currentFacing, interval = 0.1, 270 * DEG_TO_COORD, nil, 0.1
local GetPlayerFacing, SetTexCoord = GetPlayerFacing, compass.SetTexCoord

--OnUpdate
at.Compass.CompassFrame:SetScript('OnUpdate', function(self, elapsed)
	timer = timer + elapsed
	if timer < interval then return end
	timer = 0
	local facing = GetPlayerFacing()
	if facing ~= currentFacing then
		local coord = (facing < PI and 0.5 or 1) - (facing * ADJ_FACTOR)
		SetTexCoord(compass, coord - adjCoord, coord + adjCoord, 0.0625, 0.875)
		currentFacing = facing
	end
end)

--Update Compass' scale/alpha
function at.Compass:Update()
	if not at.Settings.Map.Compass.enabled then at.Compass.CompassFrame:Hide() else at.Compass.CompassFrame:Show() end
	compass:ClearAllPoints()
	compass:SetAllPoints(at.Compass.CompassFrame)

	at.Compass.CompassFrame:SetScale(at.Settings.Map.Compass.scale)
	at.Compass.CompassFrame:SetAlpha(at.Settings.Map.Compass.alpha)
end
