﻿local addonName, at = ...

at.Minimap = {}

at.Minimap.minimap = Minimap
at.Minimap.minimap:SetClampedToScreen(true)
GameTimeFrame:Hide()
MiniMapVoiceChatFrame:Hide()
MinimapBackdrop:SetParent(nil)--really? somehow this got parented to the Minimap allover again
MinimapBackdrop:Hide()
MinimapBorder:Hide()
MinimapBorderTop:Hide()
MinimapCluster:EnableMouse(false)

--updates the minimaps features
function at.Minimap:Update(cat)
	if cat == 'combat' then
		if at.Settings.Map.Coords.enabled then
			UIFrameFadeOut(at.Adjunct.CoordsFrame, 0.4, at.Settings.Map.Coords.alpha, 0)
		end
		if at.Settings.Map.fade == 0 then
			at.Minimap.minimap:Hide()
			at.Miniblobs.Frame:Hide()
		else
			UIFrameFadeOut(at.Miniblobs.Frame, 0.4, at.Settings.Map.alpha, at.Settings.Map.fade)
			UIFrameFadeOut(at.Minimap.minimap, 0.4, at.Settings.Map.alpha, at.Settings.Map.fade)
		end
	elseif cat == 'nocombat' then
		if at.Settings.Map.Coords.enabled then
			UIFrameFadeIn(at.Adjunct.CoordsFrame, 0.4, 0, at.Settings.Map.Coords.alpha)
		end
		if at.Settings.Map.fade == 0 then at.Minimap.minimap:Show() at.Miniblobs.Frame:Show() end
		if IsIndoors() or IsResting() or GetCurrentMapDungeonLevel() > 0 then
			at.Minimap.minimap:SetAlpha(1)
		else
			UIFrameFadeIn(at.Miniblobs.Frame, 0.4, at.Settings.Map.fade, at.Settings.Map.alpha)
			UIFrameFadeIn(at.Minimap.minimap, 0.4, at.Settings.Map.fade, at.Settings.Map.alpha)
		end
	elseif cat == 'zone' then
		if IsIndoors() or IsResting() or GetCurrentMapDungeonLevel() > 0 then
			at.Minimap.minimap:SetAlpha(1)
		else
			at.Minimap.minimap:SetAlpha(at.Settings.Map.alpha)
		end
		if GameTooltip:IsShown() and GameTooltip:GetOwner() == MinimapZoneTextButton  then
			at.Adjunct:UpdateZoneTooltip(MinimapZoneTextButton)
		end
		local sub = MinimapZoneText:GetText()
		if not not sub then
			sub = sub:len() * (at.Settings.Map.Zone.Font.size / (2 * UIParent:GetEffectiveScale()))
			MinimapZoneTextButton:Hide()
			MinimapZoneTextButton:SetWidth(sub)
			MinimapZoneText:SetWidth(sub)
			MinimapZoneTextButton:Show()
		end
	elseif cat == 'rest' then
		if IsResting() or GetCurrentMapDungeonLevel() > 0 then
			at.Minimap.minimap:SetAlpha(1)
		else
			at.Minimap.minimap:SetAlpha(at.Settings.Map.alpha or 1)
		end
	elseif cat == 'update' then
		at.Minimap.minimap:SetScale(at.Settings.Map.scale)

		MinimapZoneTextButton:ClearAllPoints()
		local sub, mody = at.Settings.Map.Zone.point, 0
		if sub == 'UP' then mody = at.Compass.CompassFrame:GetHeight()
		elseif sub == 'DOWN' then mody = at.Adjunct.CoordsFrame:GetHeight() * -1
		end
		MinimapZoneTextButton:Hide()
		MinimapZoneTextButton:SetPoint(at.Cache.Addons.directions[sub][1], at.Minimap.minimap, at.Cache.Addons.directions[sub][2], 0, mody)
		MinimapZoneTextButton:Show()

		if IsIndoors() or IsResting() or GetCurrentMapDungeonLevel() > 0 then
			at.Minimap.minimap:SetAlpha(1)
		else
			UIFrameFadeIn(at.Minimap.minimap, 0.4, at.Settings.Map.fade, at.Settings.Map.alpha)
		end

		at.Adjunct.SetFonts()

		at.Minimap.minimap:SetMaskTexture(at.Cache.Minimap.Shape.dir .. GetMinimapShape())
	end
end
at.Minimap.AnimationGroup = WorldFrame:CreateAnimationGroup()
at.Minimap.Timer = at.Minimap.AnimationGroup:CreateAnimation('Animation')
local MinimapUpdateBlink = false
at.Minimap.Timer:SetScript('OnFinished', function()
	if not at.Settings.Map.Blip.blink then return end
	MinimapUpdateBlink = not MinimapUpdateBlink
	if MinimapUpdateBlink then
		at.Minimap.minimap:SetBlipTexture(at.Cache.Minimap.Blip.Icons[at.Settings.Map.Blip.style])
	else
		at.Minimap.minimap:SetBlipTexture(at.Cache.Minimap.Blip.Icons['blit'])
	end
	at.Minimap.AnimationGroup:Play()
end)
at.Minimap.AnimationGroup:SetLooping('NONE')
--changes the blip texture for the tracking icons; if var is blank it will detect the profession
function at.Minimap:UpdateTrackingBlip(var)
	local style, num = var, 1
	if not var then
		local name, texture, active, category
		local sub = {'default', 'mine', 'herb', 'both'}
		for x = 1, GetNumTrackingTypes() do
			name, texture, active, category = GetTrackingInfo(x)
			if category == 'spell' then
				if texture == [[Interface\Icons\Spell_Nature_Earthquake]] then
					num = num +1
				end
				if texture == [[Interface\Icons\INV_Misc_Flower_02]] then
					num = num +2
				end
				style = sub[num]
			end
		end
	elseif var == 'blit' and at.Settings.Map.Blip.blink then
		style = 'blit'
	end

	if at.Settings.Map.Blip.blink or not IsResting() then
		at.Minimap.Timer:SetDuration(at.Settings.Map.Blip.refresh)
		at.Minimap.AnimationGroup:Play()
	else
		at.Minimap.Timer:SetDuration(0)
		at.Minimap.AnimationGroup:Stop()
	end
	at.Settings.Map.Blip.style = style
	at.Minimap.minimap:SetBlipTexture(at.Cache.Minimap.Blip.Icons[style])
	print(addonName .. ": Node style set to " .. style .. ".")
end

--some minor tweaks
WorldMapFrame:HookScript('OnHide', SetMapToCurrentZone)
--This function in particular is used by some external addons
function GetMinimapShape()
	return at.Cache.Minimap.Shape.list[at.Settings.Map.shape] or 'ROUND'
end

--mouse click handlers
at.Minimap.minimap:SetScript('OnMouseUp', function(self, button)
	if button == 'RightButton' then
		ToggleDropDownMenu(1, nil, MiniMapTrackingDropDown, 'cursor')
	elseif button == 'MiddleButton' then
		if IsShiftKeyDown() then
			ToggleTimeManager()
		else
			ToggleCalendar()
		end
	else
		Minimap_OnClick(self)
	end
end)
DropDownList1:SetClampedToScreen(true)

-- Zoom
at.Minimap.minimap:EnableMouseWheel(true)
at.Minimap.minimap:SetScript('OnMouseWheel', function(self, num)
    if num > 0 then
        Minimap_ZoomIn()
    else
        Minimap_ZoomOut()
    end
end)

--This overrides Astrolabe so I don't have to work with that library.
function at.Minimap.minimap:GetWidth()
	local width = at.Minimap.minimap:GetSize()--it HAS TO BE SQUARE there for it should return the same value for both
	return width * at.Minimap.minimap:GetScale()
end
function at.Minimap.minimap:GetHeight()
	local height = at.Minimap.minimap:GetSize()
	return height * at.Minimap.minimap:GetScale()
end

function at.Minimap:UnparentChildren()
	for x, v in ipairs({ at.Minimap.minimap:GetChildren() }) do
		name = v:GetName()
		if name ~= nil then--anything that can't be determined as an addon icon is treated as a default icon
			--if at.Abet:ExistsInTablePatternMatch(at.Settings.Addons.ignore, name) then
				--v:SetParent(at.Core)
			--else
			if not at.Abet:ExistsInTablePatternMatch(at.Settings.Addons.ignore, name) and ( at.Abet:ExistsInTablePatternMatch(at.Cache.Addons.capture, name) or at.Abet:ExistsInTablePatternMatch(at.Settings.Addons.capture, name) ) then
				v:SetParent(at.Adjunct.ButtonFrame)
				v:HookScript("OnClick", function() if at.Settings.Addons.ButtonFrame.Fade.enabled then at.Adjunct.ButtonFrame:Hide() end end)
				v:RegisterForDrag()--unregister buttons that are movable
				--tinsert(at.Settings.Addons.capture, name)
			else
				v:SetParent(at.Core)
			end
		else
			v:SetParent(at.Core)
		end
	end
end

at.Core:HookScript('OnUpdate', function()
	if at.Minimap.minimap:GetNumChildren() > 0 then
		at.Minimap:UnparentChildren()
	end
end)
