local addonName, at = ...

at.Options = {}

--loaded last

--slash commands
local function getCommands(arg)
	local aTable = {}
	for v in string.gmatch(arg, "[^ ]+") do
		tinsert(aTable, v)
	end
	return aTable[1], aTable[2], aTable[3], aTable[4], aTable[5], aTable[6], aTable[7]
end

_G['SLASH_' .. addonName .. 1] = "/jmm"
SlashCmdList[addonName] = function(msg)
	if at.Cache.InCombat then print("Commands disabled in combat.") return end

	local function oops() print(addonName .. ": Invalid command.") end
	local function voops() print(addonName .. ": Invalid value.") end
	local com1, com2, value, parent, relative, x, y = getCommands(msg)
	if type(com1) == 'string' then com1 = com1:lower() end
	if type(com2) == 'string' and com1 ~= 'capture' and com1 ~= 'ignore' then com2 = com2:lower() end

	if com1 == 'unlock' then
		at.Movers:Show()

	elseif com1 == 'lock' then
		at.Movers:Hide()

	elseif com1 == 'reset' then
		print(addonName .. "This is currently not fully operational.")
		--return
		--TODO
		--local point, anchor, relativePoint, xOfs, yOfs
	elseif com1 == 'toggle' then
		ToggleMinimap()
	elseif com1 == 'version' then
		print(addonName .. " Version: " .. at.Cache.Version.number)
	elseif com1 == 'help' or not com1 then
		local color = {
			default = "|cff3399FF",
			coords = "|cff19FF19",
			map = "|cff4FC1FF",
			blip = "|cffFF5050",
			compass = "|cffF2FF06",
			mouse = "|cffEE44EE",
			icons = "|cff90EE90",
			profile = "|cffEDB60E",
			blobs = "|cffEE8AE7",
			abf = "|cff95E287",
		}
	-- Print commands
		print(color.default .. addonName .. "|r commands: /jmm command")
		print(color.default .. "  Hold SHIFT + ALT + Left-Click to move the Minimap, release SHIFT + ALT to place the Minimap.")
		print(color.default .. "  toggle|r - Toggle Minimap on or off.")
		print(color.default .. "  un/lock|r - Hide/Show frame movers for dragging.")
		--print(color.default .. "  reset|r - Reset Mover frames to their default positions.")
		print(color.default .. "  arrow|r show/hide - Show/Hide the " .. addonName .. " arrow for TomTomLite.")
		print(color.default .. "  date|r show/hide - Show/Hide the date under the clock.")
		print(color.default .. "  pbattle|r - Toggles hiding in pet battles.")
		print(color.default .. "  fonts|r - List all available fonts; this includes from some addons.")
		print(color.default .. "|rTo see the name of buttons use the following: /fstack.")
		print(color.default .. "  ignore|r value - Will add/remove the name given or list them.")
		print(color.default .. "  capture|r value - Will add/remove the name given or list them.")

		print(color.coords .. "Coordinates|r commands: /jmm coords command")
		print(color.coords .. "  enabled|r - Show/Hide the coordinates under the clock.")
		print(color.coords .. "  alpha|r value - Sets the alpha for the coordinates.")
		print(color.coords .. "  spacer|r value - Sets the spacer for the coordinates. Current: " .. at.Settings.Map.Coords.spacer)
		print(color.coords .. "  font|r name size style - Sets the font for the coordinates and clock.")

		print(color.map .. "Minimap|r commands: /jmm map command")
		print(color.map .. "  scale|r value - Sets the scale of the minimap.")
		print(color.map .. "  alpha|r value - Sets the alpha of the minimap.")
		print(color.map .. "  shape|r value - Sets the shape of the minimap.")
		print(color.map .. "  combat|r - Toggles fading minimap in combat.")
		print(color.map .. "  fade|r value - Sets the alpha of the combat fade.")
		print(color.map .. "  parent|r - Sets the anchor/parent for the Minimap.")
		print(color.map .. "  position|r value - Sets the point on the Minimap used to relate Minimap to its anchor/parent.")
		print(color.map .. "  relative|r value - Sets the point on its anchor to relate to the Minimap.")
		print(color.map .. "  x/y|r value - Sets the x/y offset for the Minimap.")
		print(color.map .. "  point|r value - Sets point given position, anchor, relative, x, y.")

		print(color.map .. "Minimap Zone|r commands: /jmm zone command")--it's still part of the map; colorize as such
		print(color.map .. "  font|r name size style - Sets the font of the zone text.")
		print(color.map .. "  point|r value - Sets the point the Zone text will appear on the Minimap.")

		print(color.blip .. "Blip|r commands: /jmm blip command")
		print(color.blip .. "Note:  This will change gathering nodes on the Minimap.|r")
		print(color.blip .. "  Current:|r " .. at.Settings.Map.Blip.style)
		print(color.blip .. "  Choices:|r default, herb, mine, both, blit")
		print(color.blip .. "    blink|r - Toggles the Minimap node blink.")
		print(color.blip .. "    refresh|r value - Refresh rate for the Minimap node blink.")
		print(color.blip .. "    style|r value - Style of gathering nodes.")

		print(color.compass .. "Compass|r commands: /jmm compass command")
		print(color.compass .. "  enabled|r - Show/Hide the compass.")
		print(color.compass .. "  alpha|r - Sets the alpha of the compass.")
		print(color.compass .. "  scale|r - Sets the scale of the compass.")
		print(color.compass .. "  combat|r - Toggles compass fading in combat.")
		print(color.compass .. "  fade|r - Sets the alpha of the combat fade.")

		print(color.abf .. "Addon Button Frame|r commands: /jmm abf command value:")
		print(color.abf .. "  growth|r value - Direction the buttons will be displayed in.")
		print(color.abf .. "  direction|r value - Direction of the wrapping.")
		print(color.abf .. "  wrap|r value - Sets the number of items before it wraps.")
		print(color.abf .. "  fade|r value - Sets the fade timer for the button; enabled or 0 wil toggle the fading.")

		print(color.icons .. "Icon|r commands:  /jmm icons command")
		print(color.icons .. "  alpha|r value - Sets the alpha for Icons set to the Minimap.")
		print(color.icons .. "  combat|r value - Toggles Icons fading in combat.")
		print(color.icons .. "  fade|r value - Sets the alpha for combat fading.")

		print(color.blobs .. "Blob|r commands:  /jmm blobs command <value/type> <value/otherType>\nTypes: Quests, Archaeology")
		print(color.blobs .. "  quality|r value - Change the quality of the blobs; 0 is high performance, 1 is high graphics.")
		print(color.blobs .. "  filter|r value - Change the quest blob filter.\nFilters: NONE is show all, SELECTED shows only the selected quest, and WATCHED shows only watched quests.")
		print(color.blobs .. "  alpha|r type value - Change the alpha of a blob types alpa.")
		print(color.blobs .. "  style|r type otherType - Switch between Quests/blue and Archaeology/red.")

		print(color.profile .. "Profile|r commands: /jmm profile command value:")
		print(color.profile .. "  load|r value - Load a profile and use it; default, self, <user created>.")
		print(color.profile .. "  saveas|r value - Save a profile as whatever you want.\n\'default\' is of course default, \'self\' is character.")

		print(color.mouse .. "Mouse|r controls:")
		print(color.mouse .. "  left|r - Ping the minimap")
		print(color.mouse .. "  middle|r - Toggle the calendar")
		print(color.mouse .. "  SHIFT middle|r - Toggle the time manager")
		print(color.mouse .. "  right|r - Toggle the tracking menu")
		print(color.mouse .. "  wheel|r - Zoom the minimap in/out")



	--[[elseif com1 == 'icons' and (at.Abet:ExistsInTable(at.Cache.Minimap.Icons, com2) or at.Abet:ExistsInTable(at.Cache.Minimap.Icons, com2:upper())) then
		print(addonName .. "This is currently not fully operational.")

		value = value:upper()
		local sub, name
		for x, v in ipairs(stash.Mm.Icons.list) do
			name = stash.Mm.Icons.name[x]
			if com2 == name or com2:upper() == name then
				ref = _G[v]
				sub = JMmOptions[com1]['point'][name]
				for y, w in ipairs(stash.Mm.Icons.list) do
					local subName = stash.Mm.Icons.name[y]
					if value == JMmOptions[com1]['point'][subName] and name:lower() ~= subName then
						local dub = _G[w]
						JMmOptions[com1]['point'][subName] = sub
						dub:SetPoint('CENTER', Minimap, sub)
						dub:Show()
					end
				end
				JMmOptions[com1]['point'][name] = value
				ref:SetPoint('CENTER', Minimap, value)
				ref:Show()
			end
		end--]]

	elseif com1 == 'ignore' or com1 == 'capture' then
		local sub = _G[com2]
		if sub == nil then return voops() end
			if com1 == 'capture' then
				if not at.Abet:ExistsInTablePatternMatch(at.Settings.Addons.capture, name) then
					sub:SetParent(at.Adjunct.ButtonFrame)
					sub:HookScript("OnClick", function() if at.Settings.Addons.ButtonFrame.Fade.enabled then at.Adjunct.ButtonFrame:Hide() end end)
					sub:RegisterForDrag()
					tinsert(at.Settings.Addons[com1], com2)
				else
					at.Abet:DeleteFromTable(at.Adjunct.Addons[com1], com2)
					print(addonName .. ": This will require a reload.")
				end
			elseif com1 == 'ignore' then
				if not at.Abet:ExistsInTablePatternMatch(at.Settings.Addons.ignore, name) then
					sub:SetParent(at.Core)
					--sub:HookScript("OnClick", function() if at.Settings.Addons.ButtonFrame.Fade.enabled then at.Adjunct.ButtonFrame:Hide() end end)
					--sub:RegisterForDrag()
					tinsert(at.Settings.Addons[com1], com2)
				else
					at.Abet:DeleteFromTable(at.Adjunct.Addons[com1], com2)
					print(addonName .. ": This will require a reload.")
				end
			end

	elseif com1 == 'abf' then
		if com2 == 'growth' then
			value = value:upper()
			if at.Abet:ExistsAsTableKey(at.Cache.Addons.directions, value) then
				if at.Abet:ExistsInTable(at.Cache.Addons.directions[value], at.Cache.Addons.directions[at.Settings.Addons.ButtonFrame.growth][1]) then
				at.Settings.Addons.ButtonFrame.growth = value
				else voops()
				end
			else voops()
			end

		elseif com2 == 'direction' then
			value = value:upper()
			if at.Abet:ExistsAsTableKey(at.Cache.Addons.directions, value) then
				if at.Abet:ExistsInTable(at.Cache.Addons.directions[value], at.Cache.Addons.directions[at.Settings.Addons.ButtonFrame.direction][1]) then
					at.Settings.Addons.ButtonFrame.direction = value
				else voops()
				end
			else voops()
			end

		elseif com2 == 'wrap' then
			local value = tonumber(value)
			if value > -1 then
				at.Settings.Addons.ButtonFrame.wrap = tonumber(value)
			else voops()
			end

		elseif com2 == 'fade' then
			local sub = tonumber(value)
			if not not sub and sub > 12 then
				at.Settings.Addons.ButtonFrame.Fade.value = sub
				at.Adjunct.ButtonFrameTimer:SetDuration(sub)
			elseif value == 'enabled' or value == 0 then
				at.Settings.Addons.ButtonFrame.Fade.enabled = not at.Settings.Addons.ButtonFrame.Fade.enabled
			else voops()
			end

		else oops()
		end
		at.Adjunct.ButtonFrame:Hide()
		if not at.Settings.Addons.ButtonFrame.Fade.enabled then
			at.Adjunct.ButtonFrame:Show()
		end

	elseif com1 == 'blip' then
		if com2 == 'blink' then
			at.Settings.Map.Blip.blink = not at.Settings.Map.Blip.blink
			--if not at.Settings.Map.Blip.blink then
				--Minimap:SetBlipTexture(at.Cache.Minimap.Blip.Icons[at.Settings.Map.Blip.style])
			--end
		elseif com2 == 'style' then
			at.Settings.Map.Blip.style = value
			--at.Minimap:UpdateTrackingBlip(value)
			--Minimap:SetBlipTexture(at.Cache.Minimap.Blip.Icons[at.Settings.Map.Blip.style])
		elseif com2 == 'refresh' then
			--value = tonumber(value)
			at.Settings.Map.Blip.refresh = tonumber(value)
		else return oops()
		end
		at.Minimap:UpdateTrackingBlip(at.Settings.Map.Blip.style)

	elseif com1 == 'pbattle' then
		at.Settings.PetBattle = not at.Settings.PetBattle

	--authoring debug reset command
	elseif com1 == 'author' then
		if com2 == 'reset' then
			if value == at.Cache.Version.number then
				JMMDB = nil
				JMMCharacterDB = nil
				ReloadUI()
			end
		end

	elseif com1 == 'profile' then
		if com2 == 'list' then
			print("Current: " .. JMMCharacterDB.Profile.current)
			for x, v in pairs(JMMDB.Profile) do print(x) end

		--load and set to
		elseif com2 == 'load' then
			local sub = JMMCharacterDB.Profile.current
			if sub == 'self' then
				JMMCharacterDB.Settings =  at.Abet:CopyTable(at.Settings)
			elseif sub == 'default' then
				local dub = at.Abet:CopyTable(JMMDB.Profile)
				JMMDB =  at.Abet:CopyTable(at.Settings)
				JMMDB.Profile = dub
			else
				JMMDB.Profile[sub] = at.Abet:CopyTable(at.Settings)
			end
			if value == 'default' then
				at.Settings = at.Abet:CopyTable(JMMDB)
				at.Settings.Profile = nil
			elseif value == 'self' then
				at.Settings = at.Abet:CopyTable(JMMCharacterDB.Settings)
			else
				at.Settings = at.Abet:CopyTable(JMMDB.Profile[value])
			end
			at.Minimap:Update('update')
			at.Compass:Update()
			JMMCharacterDB.Profile.current = value

		--saves the users data
		elseif com2 == 'saveas' then
			local sub = JMMCharacterDB.Profile.current
			if sub == 'self' then
				JMMCharacterDB.Settings =  at.Abet:CopyTable(at.Settings)
			elseif sub == 'default' then
				local dub = at.Abet:CopyTable(JMMDB.Profile)
				JMMDB =  at.Abet:CopyTable(at.Settings)
				JMMDB.Profile = dub
			else
				JMMDB.Profile[sub] = at.Abet:CopyTable(at.Settings)
			end
			if value == 'self' then
				JMMCharacterDB.Settings =  at.Abet:CopyTable(at.Settings)
			elseif value == 'default' then
				local dub = at.Abet:CopyTable(JMMDB.Profile)
				JMMDB =  at.Abet:CopyTable(at.Settings)
				JMMDB.Profile = dub
			else
				JMMDB.Profile[value] = at.Abet:CopyTable(at.Settings)
			end
			JMMCharacterDB.Profile.current = value
		--delete a profile
		elseif com2 == 'delete' then
			if value == 'default' or value == 'self' or value == JMMCharacterDB.Profile.current then return voops() end
			JMMDB.Profile[value] = nil
		end

	elseif com1 == 'blobs' then
		if com2 == 'filter' then
			--'NONE', 'WATCHED', 'SELECTED'
			at.Miniblobs:SetQuestsFilter ( value:upper() )
		elseif com2 == 'quality' then
			value = tonumber(value)
			if value >= 0 and value <= 1 then
				at.Miniblobs:SetQuality ( value )
			else
				print(addonName .. ": " .. '0 to 1')
			end
		elseif com2 == 'style' then
			at.Miniblobs:SetTypeStyle ( value, parent )
		elseif com2 == 'alpha' then
			at.Miniblobs:SetTypeAlpha ( value, tonumber(parent) )
		end

	elseif com1 == 'fonts' then
		local styles = {
			'OUTLINE', 'THICKOUTLINE', 'MONOCHROME', 'NONE',
		}
		at.Abet:ListFonts()
		print(addonName .. ': Font Styles')
		for x, v in pairs(styles) do print( v) end

	elseif type(com1) == 'string' or com2 == 'hide' then
		--ref2 is a modified string because I'm stupid/lazy
		local ref, ref2 = nil, string.sub(com1, 1, 1):upper() .. string.sub(com1, 2)

		if com1 == 'map' then ref = Minimap
		elseif com1 == 'zone' then ref = MinimapZoneTextButton
		elseif com1 == 'compass' then ref = at.Compass.CompassFrame
		elseif com1 == 'icons' then ref = at.Core
		elseif com1 == 'coords' then ref = at.Adjunct.CoordsFrame
		elseif com1 == 'date' then ref = at.Adjunct.DateText
		elseif com1 == 'arrow' then ref = _G["TomTomLiteArrow"]
		else
			ref = _G[com1]
			if not ref then return oops() end
		end

		if com2 == 'alpha' then
			value = tonumber(value)
			if value then
				--safety net; user should use hide instead
				if value < 0.25 then
					value = 0.25
				elseif value > 1 then
					value = 1
				end
			end
			if com1 == 'map' then
				at.Settings.Map.alpha = value
			else
				at.Settings.Map[ref2][com2] = value
			end
			ref:SetAlpha(value)
		elseif com2 == 'enabled' then
			if com1 =='arrow' then
				at.Settings.Arrow = not at.Settings.Arrow
				if IsAddOnLoaded("TomTomLite") then
					if at.Settings.Arrow then
						ref.arrow:SetTexture(at.Cache.Arrow.JMMArrow)
						ref.glow:SetTexture(at.Cache.Arrow.JMMGlow)
					else
						ref.arrow:SetTexture(at.Cache.Arrow.arrow)
						ref.glow:SetTexture(at.Cache.Arrow.glow)
					end
				end
			elseif com1 == 'date' then
				at.Settings.Map[ref2] = not at.Settings.Map[ref2]
				if at.Settings.Map[ref2] then
					UIFrameFadeIn(ref, 0.5, at.Settings.Map[ref2].fade or 0, at.Settings.Map[ref2].alpha or 1)
				else
					UIFrameFadeOut(ref, 0.5, at.Settings.Map[ref2].alpha or 1, at.Settings.Map[ref2].fade or 0)
				end
			else
				at.Settings.Map[ref2][com2] = not at.Settings.Map[ref2][com2]
				if at.Settings.Map[ref2][com2] then
					UIFrameFadeIn(ref, 0.5, at.Settings.Map[ref2].fade or 0, at.Settings.Map[ref2].alpha or 1)
				else
					UIFrameFadeOut(ref, 0.5, at.Settings.Map[ref2].alpha or 1, at.Settings.Map[ref2].fade or 0)
				end
			end
		elseif com2 == 'combat' then
			if com1 == 'map' then
				at.Settings.Map[com2] = not at.Settings.Map[com2]
			else
				at.Settings.Map[ref2][com2] = not at.Settings.Map[ref2][com2]
			end
		elseif com2 == 'fade' then
			at.Settings.Map[ref2][com2] = tonumber(value)
		elseif com2 == 'scale' then
			value = tonumber(value)
			if value then
				if value < 0.5 then
					value = 0.5
				elseif value > 2 then
					value = 2
				end
			end
			if com1 == 'map' then
				at.Settings.Map.scale = value
			else
				at.Settings.Map[ref2].scale = value
			end
			ref:SetScale(value)
		elseif com2 == 'shape' then
			value = value:upper()
			if at.Abet:ExistsInTable(at.Cache.Minimap.Shape.list, value) then
				at.Settings.Map.shape = at.Abet:GetTableValueIndex(at.Cache.Minimap.Shape.list, value)
			else
				local sub = ''
				for x, v in pairs(at.Cache.Minimap.Shape.list) do
					sub = sub .. ", " .. v
				end
				print(addonName .. ": " .. sub)
			end

			--nudge
		elseif com2 == 'anchor' or com2 == 'position' or com2 == 'relative' or com2 == 'x' or com2 == 'y' then
			local point, relativeTo, relativePoint, xOfs, yOfs = ref:GetPoint()
			if com2 == 'anchor' then
				if not _G[value] then oops() end
				ref:SetPoint(point, _G[value], relativePoint, xOfs, yOfs)

			elseif com2 == 'point' then
				ref:SetPoint(value:upper(), relativeTo, relativePoint, xOfs, yOfs)

			elseif com2 == 'relative' then
				ref:SetPoint(vpoint, relativeTo, value:upper(), xOfs, yOfs)

			elseif com2 == 'x' then
				ref:SetPoint(point, relativeTo, relativePoint, tonumber(value), yOfs)

			elseif com2 == 'y' then
				ref:SetPoint(point, relativeTo, relativePoint, xOfs, tonumber(value))

			else
				ref:SetPoint(value, _G[parent], relative, x, y)

			end

		elseif com2 == 'font' then
			if com1 == 'zone' then ref = MinimapZoneText
			elseif com1 == 'coords' then ref = at.Adjunct.CoordsFrameText end
			if ref:GetFont() == nil then return oops() end
			local styles = {
				'OUTLINE', 'THICKOUTLINE', 'MONOCHROME', 'NONE',
			}
			if value == 'list' then
				at.Abet:ListFonts()
				print(addonName .. ': Font Styles')
				for x, v in pairs(styles) do print( v) end
			end
			local font = at.Abet:GetFont(value)
			relative = relative:upper()
			parent = tonumber(parent)
			if not at.Abet:ExistsInTable(styles, relative) or parent == nil or font == nil then return voops() end
			at.Settings.Map[ref2].Font = {
				name = font,
				size = parent,
				style = relative,
			}
			ref:SetFont(font, parent, relative)
			if com1 == 'coords' then
				local clockFrame, clockTime = TimeManagerClockButton:GetRegions()
				clockTime:SetFont(font, parent, relative)
				at.Adjunct.DateText:SetFont(font, parent, relative)
			elseif com1 == 'zone' then
				at.Adjunct.WandererInfoText:SetFont(font, parent, relative)
				at.Minimap:Update('zone')
				MinimapZoneTextButton:SetHeight(parent + 2)
			end
		elseif com2 == 'point' then
			if ref ~= MinimapZoneTextButton then return oops() end
			value = value:upper()
			if at.Abet:ExistsAsTableKey(at.Cache.Addons.directions, value) then
				at.Settings.Map.Zone.point = value
			else voops()
			end
			at.Minimap:Update('update')

		elseif com2 == 'spacer' then--coords
			at.Settings.Map.Coords.spacer = value

		else
			return oops()
		end

		if com1 == 'map' then at.Minimap:Update('update')
		elseif com1 == 'compass' then at.Compass:Update() end
	else
		return oops()
	end
end

print("|cff3544FFJ|rMinimap has been loaded, use /jmm or /jmm help for help.")
